/*
  A hash routine (very poor one) written by Jonathan Roy, 
  roy@atlantic.net. If you have a nicer one, please let me know. ;)
*/

#include "hash.h"

struct hash_element *htable[4007];
struct prhash_element *prhtable[199];

int hashinitdone = 0;

void
inithash()
{
	int i=0;
	int index=0;
	opcode_t *op;
	char tmpchar[40];
	struct prhash_element *cell, *last;

	for (i=0; i<4007; i++) {
		htable[i] = NULL;
	}
	for (i=0; i<199; i++) {
		prhtable[i] = NULL;
	}

	for (op=pr_opcodes ; op->name ; op++) {
		sprintf(tmpchar, "%s", op->name);
		index = prhash(tmpchar);
		cell = malloc (sizeof(struct prhash_element));
		last = prhtable[index];
		while(last != NULL && last->next != NULL)
			last=last->next;
		cell->next = NULL;
		cell->op = op;
		if (last == NULL)
			prhtable[index] = cell;
		else
			last->next = cell;
	}

	hashinitdone=1;
}

#ifndef INLINE
int
hash(char *string)
{
	int index=0;
	int count=0;

        for(count=0; string[count]!='\0' && count<20; count++) {
		index = (index << 1) + (string[count] << 1);
	}

	return index % 4007;
}

int
prhash(char *string)
{
	int index=0;
	int count=0;

        for(count=0; string[count]!='\0' && count<5; count++) {
//		index = (index << 1) + (string[count] << 1);
		index = (index << 1) + (string[count]);
	}

	return index % 199;
}
#endif
